> ![MikroE](http://www.mikroe.com/img/designs/beta/logo_small.png)
> #EEPROM 3 click#
> ##By [MikroElektronika](http://www.mikroe.com)
---

## Installation
Use the package manager to install the library for your architecture.

###Example
```
#include <stdint.h>
#include "resources.h"
#include "eeprom_3_hw.h"

// TFT pins
/*
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;
*/
// VARIABLES
uint16_t _address_ = 0x0123;
char _data_[20] = { "MikroElektronika" };
char _empty_[20] = { 0 };
char _last_operation_[10];
unsigned char buff[20];

// FUNCTION PROTOTYPES
void system_init( void );
void erase_value( void );
void display_init( void );
void write_value( void );
void read_value( void );

// FUNCTION DEFINITIONS
void system_init()
{                                 
    I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
    Delay_ms( 500 );
    
    GPIO_Digital_Input( &GPIOC_BASE, _GPIO_PINMASK_7 );
    GPIO_Digital_Input( &GPIOC_BASE, _GPIO_PINMASK_2 );
    GPIO_Digital_Input( &GPIOC_BASE, _GPIO_PINMASK_3 );
    strcpy( _last_operation_, "" );
    Delay_ms( 100 );
}

void display_init()
{
    TFT_Init_ILI9341_8bit( 320, 240 );
    TFT_BLED = 1;
    TFT_Set_Pen( CL_WHITE, 1 );
    TFT_Set_Brush( 1,CL_WHITE,0,0,0,0 );
    TFT_Set_Font( TFT_defaultFont, CL_BLACK, FO_HORIZONTAL );
    TFT_Fill_Screen( CL_WHITE );
    TFT_Set_Pen( CL_BLACK, 1 );
    TFT_Line(  20,  46, 300,  46 );
    TFT_Line(  20,  70, 300,  70 );
    TFT_Line(  20, 110, 220, 110 );
    TFT_Line(  20, 196, 300, 196 );
    TFT_Line(  20, 202,  20, 214 );
    TFT_Line(  20, 220, 300, 220 );
    TFT_Line( 113, 202, 113, 214 );
    TFT_Line( 206, 202, 206, 214 );
    TFT_Line( 300, 202, 300, 214 );
    TFT_Set_Pen( CL_WHITE, 1 );
    TFT_Set_Font( &HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL );
    TFT_Write_Text( "EEPROM  3 click", 85, 14 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_BLUE, FO_HORIZONTAL );
    TFT_Write_Text( "AT24CM02", 120, 50 );
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text( "Last Operation :", 30, 75 );
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text( "Current Operation :", 30, 115 );
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text("EasyMx PRO v7 for STM32", 19, 223);
    TFT_Set_Font( &Verdana12x13_Regular, CL_RED, FO_HORIZONTAL );
    TFT_Write_Text( "www.mikroe.com", 200, 223 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_GREEN, FO_HORIZONTAL );
    TFT_Write_Text( "PC3 -", 25, 200 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_BLUE, FO_HORIZONTAL );
    TFT_Write_Text( "PC2 -", 118, 200 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_RED, FO_HORIZONTAL );
    TFT_Write_Text( "PC7 -", 211, 200 );
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text("Write", 65, 201);
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text("Read", 158, 201);
    TFT_Set_Font( &Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text("Erase", 251, 201);
    TFT_Image_Jpeg( 240, 115, &AT24CM02_jpg );
}

void erase_value()
{
    TFT_Rectangle( 78, 90, 148, 108 );
    TFT_Write_Text( _last_operation_, 80, 90 );
    eeprom_3_write_page( _address_, _empty_, 17 );
    TFT_Set_Pen( CL_WHITE, 1 );
    TFT_Rectangle( 18, 133, 198, 193 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_RED, FO_HORIZONTAL );
    TFT_Write_Text( "ERASED", 80, 135 );
    strcpy( _last_operation_, "ERASING" );
}

void write_value()
{
    TFT_Rectangle( 78, 90, 148, 108 );
    TFT_Write_Text( _last_operation_, 80, 90 );
    eeprom_3_write_page( _address_, _data_, 17 );
    TFT_Set_Pen( CL_WHITE, 1 );
    TFT_Rectangle( 18, 133, 198, 193 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text( _data_, 60, 160 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_GREEN, FO_HORIZONTAL );
    TFT_Write_Text( "WRITTEN", 80, 135 );
    strcpy( _last_operation_, "WRITTING" );
}

void read_value()
{
    TFT_Rectangle( 78, 90, 148, 108 );
    TFT_Write_Text( _last_operation_, 80, 90 );
    eeprom_3_random_address_read( _address_, buff, 17 );
    TFT_Set_Pen( CL_WHITE, 1 );
    TFT_Rectangle( 18, 133, 198, 193 );
    Delay_ms( 200 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_BLACK, FO_HORIZONTAL );
    TFT_Write_Text( buff, 60, 160 );
    TFT_Set_Font( &Tahoma15x16_Bold, CL_BLUE, FO_HORIZONTAL );
    TFT_Write_Text( "READ", 80, 135 );
    strcpy( _last_operation_, "READING" );
}

void main() 
{
     system_init();
     display_init();
     
     // EEPROM Initialization 
     // Device HW address depends on jumper position - 0xA0 or 0xA8
     eeprom_3_init( 0xA0 );
     
     while( 1 )
     {
         if ( Button( &GPIOC_IDR, 7, 80, 1 ) )
             erase_value();
             
         if ( Button( &GPIOC_IDR, 2, 80, 1 ) )
             read_value();

         if ( Button( &GPIOC_IDR, 3, 80, 1 ) )
             write_value();
     }
}
```
